% function [codebookNumber]= getCodebook(SIFTfeatures ,SIFTkeys, newX, newY ,thersholdSIFT)
% if size(SIFTfeatures,1)==0
%     codebookNumber=0;
% else
%     load key5ClustersCOIL16.mat
%     codeBooks = calcCodeBooks(SIFTkeys,D);
%     maxFrequency = -inf;
%     for i=1:size(D,1)
%         [u v] = find(codeBooks==i);
%         if size(u,2)> maxFrequency 
%             maxFrequency = size(u,2);
%             codebookNumber = i;
%         end
%     end
% 
% end
% end
% 
% function codeBooks = calcCodeBooks(SIFTkeys,D)
% codeBooks = [];
% for i=1:size(SIFTkeys,1)
%     min = inf;
%     index = 0;
%     for j=1: size(D,1)
%         temp = norm(SIFTkeys(i)-D(j));
%         if  temp < min
%             min = temp;
%             index = j;
%         end
%     end
%     codeBooks = [codeBooks index];
% end
% 
% end
% 


function [codebookNumber]= getCodebook(SIFTfeatures ,SIFTkeys, newX, newY ,thersholdSIFT)
global D; 

if size(SIFTfeatures,1)==0
    codebookNumber=0;
else

    siftNumber = getSift(SIFTfeatures,newX,newY,thersholdSIFT);
    if siftNumber <= 0
        codebookNumber=0;
    else
        clear siftKey;
        siftKey = SIFTkeys(siftNumber,:);
%         load key10Clusters.mat
        %---------- find best cluster-----------------
        distanceCluster =  zeros(1, size(D,1));
        for i=1: size(D,1)
            for j=1: size(D,2)
                distanceCluster(1,i)= distanceCluster(1,i)+( D(i,j) - siftKey(1,j) )^2;
            end
        end
        [val index] = min(distanceCluster);
        codebookNumber = index;
    end
end
end

function [index ]= getSift(SIFTfeatures,x,y,thersholdSIFT)
minSift = [];
index=0;
for sNumber=1: size(SIFTfeatures,1)
    SiftX = SIFTfeatures(sNumber,1);
    SiftY = SIFTfeatures(sNumber,2);
    minSift = [minSift ,sqrt((SiftX-x)^2+(SiftY-y)^2)];
end
[ val index] = min(minSift);
% if val> thersholdSIFT
%     index =0; % null, there is no sift in this window
% end

end

function [index ]= getSift2(SIFTkeys,x,y,thersholdSIFT)
% New SIFT written by ALI
% In this implementation the SIFT feature with the highest magnitude is
% selected
minSift = [];
index=0;
maxMag = -10;
for sNumber=1: size(SIFTkeys,2)
    if norm(SIFTkeys(sNumber)) > maxMag
        maxMag = sNumber;
        index = sNumber;
    end
end

end