function postPrune()
global node;
global QTable;

for nodeCounter=1:size(node,2)
%     (node(nodeCounter).useful == 1)
    if (size(node(nodeCounter).childs,2) ~= 0 )&& (node(nodeCounter).useful==1)
        sa = getSiblingAction(nodeCounter);

        if size(sa.sibling,2)==1
            % the node should be deleted from tree and its paretn should take its place % az a leaf
        end

        if size(sa.sibling,2)>1
            %find sibling with same action
            action = sort( sa.action );
            while size(action,2)>1
                index = find( sa.action == action(1) );
                siblingSameAction = sa.sibling(index);
                stateNum = sa.stateNum(index);
                codebook = sa.codebook(index);
                margeSibling(siblingSameAction, nodeCounter ,stateNum,codebook);
                sa.action(index)=[];
                sa.stateNum(index)=[];
                sa.sibling(index)=[];
                sa.codebook(index)=[];
                action = sort( sa.action );
            end
        end
    end
end
end

function margeSibling(sibling,parent,stateNum,codebook)
global node;
global QTable;

for saNumber=2: size(sibling,2)
   stateNum1 = find(QTable(:,1) == sibling(saNumber));
    QTable = removerows(QTable,stateNum1);   
    node(sibling(saNumber)).parent=0;
    node(sibling(saNumber)).useful=0;
    node(parent).childs(node(sibling(1)).childID).codebook = ...
        [ node(parent).childs(node(sibling(1)).childID).codebook  codebook(saNumber)];
end
end

function sibling = getSibling(parent)
global QTable;
global node;
sibling =[];
for i=1: size(node,2)
    if size(node(i).childs,2)==0 && node(i).parent== parent 
        sibling = [sibling i];
    end
end
end

function sa = getSiblingAction(parent)
global node;
global QTable;
sa.sibling =[]; sa.action =[]; sa.stateNum=[]; sa.codebook=[];
for i=1: size(node(parent).childs,2)
    if size(node(node(parent).childs(i).ID).childs,2)==0
        sa.sibling = [sa.sibling node(parent).childs(i).ID];
        stateNum1 = find(QTable(:,1) == node(parent).childs(i).ID);
        [val action ] = max(QTable(stateNum1,2:end));
        sa.action = [sa.action action];
        sa.stateNum=[sa.stateNum stateNum1 ];
        sa.codebook=[sa.codebook node(parent).childs(i).codebook];
    end
end

end

function action = getnodeAction(nodeID)
global QTable;
global node;
stateNum1 = find(QTable(:,1) == nodeID);
[val action ] = max(QTable(stateNum1,2:end));
end