function SIFTs = calcAllFeatures
 
% SiftFs = [];
% SiftKs = [];

% dataSetPath ='D:\Thesis\-COIL100-16\';
dataSetPath ='D:\Thesis\COIL-36\';
%  randImage = randint(1,1,[1 7]); % randomly select among 23 pictures of a scene

for k=1:100

    dirName = [dataSetPath  'Obj' int2str(k) '__' int2str(0) '.png'];
    nextImage = imreadbw(dirName);

    nextImage =nextImage -min(nextImage(:)) ;
    nextImage =nextImage /max(nextImage(:)) ;

    [SIFTfeatures,SIFTkeys,gss1, dogss1 ] = sift(nextImage, 'Verbosity', 0 ) ;

    Features(k).SiftFs =  SIFTfeatures;
    Features(k).SiftKs =  SIFTkeys;
    Features(k).dirName =  dirName;
    
end % k

save Features100; 

% Clustering key features

load Features100; 

Keys = [];
for k=1:100
Keys = [Keys;Features(k).SiftKs'];
end
    
[IDX,D] = kmeans(Keys,5);

save key5ClustersCOIL100.mat; 
end


