function  AverageVar = modifyTreeVariance(nextNode)
global QTable;
global node;
global saccadDirections;
global nodeIDCounter;
global nActions;
global aliasingTherehold;
global vectorLength;
global Features; 

% check aliasing
aliasing =0;
probAttribs =[];
for i=1: nActions % action number
    fTemp = find(node(nextNode).mem(:,saccadDirections+2) == i);
    if size(fTemp,1) > 0
        aliasigVar = var(node(nextNode).mem(fTemp,saccadDirections+1));
        AverageVar(i) = aliasigVar;
        if aliasigVar > aliasingTherehold
            aliasing =1;
            break;
        end
    end
end

AverageVar = max(AverageVar);
selectedFeature = [];
selectedRation = 1e+10;
probAttribs = [];
if aliasing
    for actionCounter=1:nActions

        for kk=1: saccadDirections
            prob(kk).attributes=[];
        end

        for memCount = 1: size(node(nextNode).mem,1)
            if node(nextNode).mem(memCount,saccadDirections+2) == actionCounter
                for aCounter =1: saccadDirections
                    valAttrib = node(nextNode).mem(memCount,aCounter);
                    attribPos = find( prob(aCounter).attributes == valAttrib);
                    if size(attribPos,2) == 0
                        if (attribPos == 0)
                            attribPos = 1;
                        end
                        prob(aCounter).attributes = [ prob(aCounter).attributes   valAttrib ];
                        attribPos = size( prob(aCounter).attributes ,2);
                        prob(aCounter).attr(attribPos).val = [];
                    end
                    prob(aCounter).attr(attribPos).val = [prob(aCounter).attr(attribPos).val ,...
                        node(nextNode).mem(memCount,saccadDirections+1)]  ;
                end
            end
        end

        L=0;

        for aCounter =1: saccadDirections
            %             [val exist]= findCell(usedAttnetions,wordsAttention(aCounter));
            %             if exist~=1
            sum=0;
            for attribPos=1: size(prob(aCounter).attributes,2)
                varAttrib(attribPos) = var(prob(aCounter).attr(attribPos).val);
                La = size(prob(aCounter).attr(attribPos).val,2);
                L = L + La;
                sum = sum  + (La) * varAttrib(attribPos);
            end
            gainRatio(aCounter) = sum / L;
            if selectedRation > gainRatio(aCounter) && (sum > 0)  %&& (p <= 0.05)
                selectedRation = gainRatio(aCounter);
                selectedFeature= aCounter;
                probAttribs = prob(selectedFeature).attributes;
            end
            %end
        end
    end
    if size( probAttribs,2)> 1

        if size( probAttribs,2 )>0
            node(nextNode).direction = selectedFeature;
            stateNum = find(QTable(:,1)' ==  nextNode);
            QTable = removerows(QTable,stateNum);
        end
        for childCounter = 1: size( probAttribs ,2 )
            nodeIDCounter = nodeIDCounter + 1;
            node(nextNode).childs(childCounter).ID = nodeIDCounter;
            node(nextNode).childs(childCounter).codebook = probAttribs(childCounter);
            node(nodeIDCounter).ID = nodeIDCounter;
            node(nodeIDCounter).childID = childCounter;
            node(nodeIDCounter).parent = nextNode;
            node(nodeIDCounter).length = vectorLength; % Initial search range is 30 pixels
            node(nodeIDCounter).direction = 0;
            node(nodeIDCounter).useful=1;
            QTable = [QTable ; nodeIDCounter,  ones(1 , nActions)/nActions];
        end
        node(nextNode).mem=[];
        %---------------modify tree
    end
end
end% function
