function [SIFTfeatures,SIFTkeys,nextNode,x,y]  = traverseTree(img,windowSIFT,thersholdSIFT, show )
global QTable;
global vectorLength;
global nodeIDCounter;
global nActions;
global node;
global currentPos;
global siftNumber;

siftNumber=1;

xOld = fix(size(img,1)/2); % 320;
yOld = fix(size(img,2)/2);  % 240;
%-----------traverse tree
flagHaschild=1;
nextNode=1;
SIFTfeatures=[];SIFTkeys=[];
SiftYOld = yOld;
SiftXOld = xOld;
while (flagHaschild ~= 0) % travese tree
    [x,y] = getNewXYSaccad(xOld,yOld,node(nextNode).direction,node(nextNode).length);
    if show
%         figure (currentPos);
%         hold on;
%         line([yOld,y],[xOld,x]);
    end
    xl = x - windowSIFT;   xr = x + windowSIFT ;
    yl = y - windowSIFT;   yr = y + windowSIFT;
    if xl<0
        xl=1; end
    if xr>size(img,1)
        xr=size(img,1); end
    if yl<0
        yl=1; end
    if yr>size(img,2)
        yr=size(img,2); end
    [SIFTfeatures,SIFTkeys,gss1, dogss1 ] = sift(img(xl:xr,yl:yr), 'Verbosity', 0 ) ;
    if size(SIFTfeatures,2)==0
        codebookNumber=0;
        if show
%             figure(currentPos);
            hold on;
            line([y,SiftYOld],[x,SiftXOld],'Color','c');
            plot(y,x,'yo');
        end
        SiftXOld=x;
        SiftYOld=y;
    else
        [codebookNumber] = getCodebook(SIFTfeatures', SIFTkeys', x,y,thersholdSIFT);
        if show
            if  size(SIFTfeatures,2)>0 % siftNumber>0 &&
                SiftX = floor(SIFTfeatures(1,siftNumber));
                SiftY = floor(SIFTfeatures(2,siftNumber));
%                 figure(currentPos);
                hold on;
                line([SiftY+yl,SiftYOld],[SiftX+xl,SiftXOld],'Color','g');
                plot((SiftY+yl),(SiftX+xl) ,'ro');
                SiftXOld = SiftX+xl;
                SiftYOld = SiftY+yl;
            end
        end
    end
    flagHaschild=0;
    for childCounter=1: size(node(nextNode).childs,2)
        if ( node(nextNode).childs(childCounter).codebook==codebookNumber)
            nextNode = node(nextNode).childs(childCounter).ID;
            flagHaschild=1;
            break;
        end
    end
    if size(node(nextNode).childs) == [0 0 ]
        break;
    end
    xOld=x;
    yOld=y;
end
if size(node(nextNode).childs,2)>0
    nodeIDCounter = nodeIDCounter+1;
    childCounter = size(node(nextNode).childs,2)+1;
    node(nextNode).childs(childCounter).ID = nodeIDCounter;
    node(nextNode).childs(childCounter).codebook = codebookNumber;

    node(nodeIDCounter).ID = nodeIDCounter;
    node(nodeIDCounter).childID = childCounter;
    node(nodeIDCounter).parent = nextNode;
    node(nodeIDCounter).length = vectorLength; % Initial search range is 30 pixels
    node(nodeIDCounter).direction =0;
    node(nodeIDCounter).mem=[];
    QTable = [QTable ; nodeIDCounter,  ones(1 , nActions)/nActions];
    nextNode= nodeIDCounter;
end
end